@import '../../styles/variables';
@import '../../styles/mixins';

$-cui-checkbox-transition-duration: .3s;
$-cui-checkbox-label-margin: .5rem;

form > .cui-checkbox {
  display: flex;
  margin-bottom: $cui-form-field-margin-bottom;

  + .cui-checkbox {
    margin-top: $cui-form-field-margin-bottom * -0.5;
  }
}

.cui-checkbox {
  display: inline-flex;

  &.cui-checkbox-spread {
    display: flex;
  }

  label {
    @include cui-no-select();
    flex: 1 1 auto;
    display: inline-flex;
    cursor: pointer;
    position: relative;
  }

  .cui-checkbox-label {
    @include cui-select();
    @include cui-break-word();
  }

  // ----- align

  .cui-checkbox-labeled {
    margin-left: $-cui-checkbox-label-margin;
  }

  .cui-checkbox-right {
    flex-direction: row-reverse;

    .cui-checkbox-labeled {
      margin-left: 0;
      margin-right: $-cui-checkbox-label-margin;
      text-align: right;
    }
  }

  .cui-checkbox-left-spread {
    justify-content: space-between;
  }

  .cui-checkbox-right-spread {
    flex-direction: row-reverse;
    justify-content: space-between;

    .cui-checkbox-labeled {
      margin-left: 0;
      margin-right: $-cui-checkbox-label-margin;
    }
  }

  // ----- states

  &.cui-checkbox-disabled label {
    cursor: not-allowed;
    opacity: $cui-disabled-opacity;
  }

  &.cdk-program-focused,
  &.cdk-keyboard-focused {
    .cui-checkbox-box {
      box-shadow: 0 0 0 2px $cui-focus-color;
    }
  }

  &.cui-checkbox-checked {
    .cui-checkbox-box {
      background-color: cui-color(primary, bg);
      border-color: cui-color(primary, bg);
      stroke: cui-color(primary, fill);
    }
    &:not(.cui-checkbox-disabled) label:hover .cui-checkbox-box {
      background-color: cui-color(primary, bg-hover);
      border-color: cui-color(primary, bg-hover);
      stroke: cui-color(primary, fill-hover);
    }
    &:not(.cui-checkbox-disabled) label:active .cui-checkbox-box {
      background-color: cui-color(primary, bg-active);
      border-color: cui-color(primary, bg-active);
      stroke: cui-color(primary, fill-active);
    }
    &:not(.cui-checkbox-indeterminate) .cui-checkbox-check {
      stroke-dashoffset: 0
    }
    &.cui-checkbox-indeterminate .cui-checkbox-dash {
      stroke-dashoffset: 0
    }
  }

  .cui-checkbox-box {
    flex-shrink: 0;
    display: inline-block;
    position: relative;
    border-radius: cui-border-radius(s);
    transition: background-color $-cui-checkbox-transition-duration ease,
                border-color $-cui-checkbox-transition-duration ease,
                box-shadow $cui-focus-transition;

    svg {
      fill: none;
      stroke-width: 2;
      stroke-linecap: round;
      stroke-linejoin: round;
      stroke-dasharray: 16px;
      stroke-dashoffset: 16px;
      transition: all $-cui-checkbox-transition-duration ease;
      width: 70%;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%) scale(.99)
    }
  }

  // ----- mode

  @mixin mode($mode) {
    &[data-cui-mode='#{$mode}'] {
      &:not(.cui-checkbox-checked) {
        .cui-checkbox-box {
          background-color: cui-color($mode, input-background);
          border: 1px solid cui-color($mode, input-border);
        }
        &:not(.cui-checkbox-disabled) label:hover .cui-checkbox-box {
          background-color: cui-color($mode, input-background-hover);
          border-color: cui-color($mode, input-border-hover);
        }
      }
    }
  }

  @include mode('primary');
  @include mode('secondary');

  // ----- sizes

  @mixin size($size) {
    &[data-cui-size="#{$size}"] {
      .cui-checkbox-box {
        height: cui-height($size) * 0.5;
        width: cui-height($size) * 0.5;
      }
      .cui-checkbox-label {
        @include cui-text($size);
      }
    }
  }

  @include size('s');
  @include size('m');
  @include size('l');
}
